SystemOrganization addCategory: #'Xpf-Client-Tests'!
SystemOrganization addCategory: #'Xpf-Client-Morphs'!
SystemOrganization addCategory: #'Xpf-Client-Helpers'!

!Morph methodsFor: '*xpf-client' stamp: 'SR 2/23/2009 10:49'!
isUserStoryMorph
	^ false! !

SystemWindow subclass: #XpfClient
	instanceVariableNames: 'projectMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Morphs'!

!XpfClient class methodsFor: 'as yet unclassified' stamp: 'SR 2/23/2009 12:12'!
newFor: anXpfProject
	^ self new
		model: anXpfProject! !

!XpfClient methodsFor: 'initialization' stamp: 'SR 2/23/2009 12:09'!
initialize
	super initialize.
	
	self projectMorph: XpfProjectMorph new.
	self addMorph: (self projectMorph) fullFrame: (LayoutFrame fractions: (0@0 corner: 1@1) offsets: (0@0 corner: 0@0)).! !

!XpfClient methodsFor: 'accessing' stamp: 'SR 2/23/2009 12:13'!
model: anXpfProject
	super model: anXpfProject.
	self setLabel: anXpfProject printString.
	self projectMorph model: anXpfProject.! !

!XpfClient methodsFor: 'accessing' stamp: 'SR 2/23/2009 12:08'!
projectMorph
	^ projectMorph! !

!XpfClient methodsFor: 'accessing' stamp: 'SR 2/23/2009 12:08'!
projectMorph: anObject
	projectMorph := anObject! !

AlignmentMorph subclass: #XpfProjectMorph
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Morphs'!

!XpfProjectMorph class methodsFor: 'initialize-release' stamp: 'SR 2/23/2009 12:11'!
newFor: anXpfProject

	^ self new
		model: anXpfProject! !

!XpfProjectMorph methodsFor: 'accessing' stamp: 'SR 2/23/2009 11:19'!
addUserStoryMorph: anXpfUserStoryMorph

	^ self addMorph: anXpfUserStoryMorph! !

!XpfProjectMorph methodsFor: 'initialization' stamp: 'SR 2/23/2009 11:19'!
buildUserStorySubmorphs

	self model userStories do: [ :userStory| 
		self addUserStoryMorph: (XpfUserStoryMorph newFor: userStory)]! !

!XpfProjectMorph methodsFor: 'accessing' stamp: 'SR 2/23/2009 12:15'!
model
	^ model! !

!XpfProjectMorph methodsFor: 'accessing' stamp: 'SR 2/23/2009 12:14'!
model: anObject

	self removeAllMorphsIn: self userStorySubmorphs. 
	model := anObject.
	self buildUserStorySubmorphs.
! !

!XpfProjectMorph methodsFor: 'accessing' stamp: 'SR 2/23/2009 10:51'!
userStorySubmorphs

	^ self allMorphs select: [:aMorph| aMorph isUserStoryMorph]! !

BorderedMorph subclass: #XpfUserStoryMorph
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Morphs'!

!XpfUserStoryMorph class methodsFor: 'defaults' stamp: 'SR 2/23/2009 11:22'!
defaultExtent
	^ 50@30 ! !

!XpfUserStoryMorph class methodsFor: 'initialize-release' stamp: 'SR 2/23/2009 10:59'!
newFor: anXpfUserStory

	^ self new
		model: anXpfUserStory! !

!XpfUserStoryMorph methodsFor: 'initialization' stamp: 'SR 2/23/2009 11:21'!
initialize
	super initialize.
	self extent: self class defaultExtent.! !

!XpfUserStoryMorph methodsFor: 'testing' stamp: 'SR 2/23/2009 10:49'!
isUserStoryMorph
	^ true! !

!XpfUserStoryMorph methodsFor: 'accessing' stamp: 'SR 2/23/2009 10:56'!
model
	^ model! !

!XpfUserStoryMorph methodsFor: 'accessing' stamp: 'SR 2/23/2009 10:56'!
model: anObject
	model := anObject! !

TestCase subclass: #XpfClientTest
	instanceVariableNames: 'project userstory1 userstory2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Tests'!

!XpfClientTest methodsFor: 'running' stamp: 'mig 2/20/2009 15:15'!
setUp
	
	super setUp.
	project := XpfProject new.
	userstory1 := XpfUserStory new.
	userstory2 := XpfUserStory new.
	
	project
		attachUserStory: userstory1;
		attachUserStory: userstory2.! !

!XpfClientTest methodsFor: 'running' stamp: 'mig 2/20/2009 15:16'!
tearDown

	project
		detachUserStory: userstory1;
		detachUserStory: userstory1.! !

!XpfClientTest methodsFor: 'tests' stamp: 'SR 2/23/2009 11:19'!
testAddUSMorphsToProjectMorph

	| sut usMorphCount |
	sut := XpfProjectMorph new.
	usMorphCount := sut userStorySubmorphs size.
	
	sut addUserStoryMorph: (XpfUserStoryMorph newFor: userstory1).
	self should: sut userStorySubmorphs size = (usMorphCount + 1).! !

!XpfClientTest methodsFor: 'tests' stamp: 'SR 2/23/2009 12:18'!
testProjectTitleDisplay

	| sut |
	sut := XpfClient newFor: project.
	
 	self should: sut label = project printString.! !

!XpfClientTest methodsFor: 'tests' stamp: 'SR 2/23/2009 10:54'!
testUserStorySubmorphs

	| sut |
	sut := XpfProjectMorph newFor: project.
	
	
	self 
		should: sut userStorySubmorphs size = project userStories size.
		
	sut userStorySubmorphs do: [ :usMorph| 
		self should: (project userStories includes: usMorph model)].! !

!XpfClientTest methodsFor: 'tests' stamp: 'SR 2/23/2009 11:31'!
testUserStoryTextContent! !
